angular.module('starter.services', ['ngCordova'])

.factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
	setObjectMsg: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
	getObjectMsg: function(key) {
      return JSON.parse($window.localStorage[key] || '[]');
    }
  }
}])
//注册
.factory('RegisterService',['$http',function RegisterService($http) {
  return {
 
    getVerificationCode: function(mobile){
      return $http.get("http://www.iflawyer.com/app/sms.asp?mobile="+mobile+"&send_code=1234");
    },

	checktel: function(mobile){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=checktel&mobile="+mobile);
    },
	checkcode: function(code){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=checkcode&code="+code);
    },
	resetpsw: function(mobile,password){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=resetpsw&password="+password+"&mobile="+mobile);
    },
	resettel: function(userid,usertype,mobile){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=resettel&userid="+userid+"&usertype="+usertype+"&mobile="+mobile);
    },
    register: function(logonname,password,mobile){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=register&logonname="+logonname+"&password="+password+"&mobile="+mobile);
    }
  };
}])
//注册结束
//登陆
.factory('LogonService',['$http',function LogonService($http) {
  return {
    logon: function(mobile,password){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=logon&password="+password+"&mobile="+mobile);
    },
	 getOpenid: function(code){
       return $http.get("https://api.weixin.qq.com/sns/oauth2/access_token?appid=wx277d1ecc36b3fb83&secret=97bcccb73ee0aef8b0a746bd0ba4e36f&code="+code+"&grant_type=authorization_code");
    },
	 getUserinfo: function(token,openid){
       return $http.get("https://api.weixin.qq.com/sns/userinfo?access_token="+token+"&openid="+openid);
    },
	 wechatlogon: function(openid,headimg){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=wechatlogon&openid="+openid+"&headimg="+headimg);
    },
	 setwechat: function(userid,usertype,openid,headimg){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=setwechat&userid="+userid+"&usertype="+usertype+"&wechatid="+openid+"&headimg="+headimg);
    },
	 simpleinfo: function(userid,usertype){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=simpleinfo&userid="+userid+"&usertype="+usertype);
    },
	 simpleinfo2: function(userid,usertype,a,b,c,d,e,f,g){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=simpleinfo&userid="+userid+"&usertype="+usertype);
    }
  };
}])

  .factory('Lawyer',['$http',function Lawyer($http) {
  return {
    collection: function(userid,usertype,lawyerid){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=collection&userid='+userid+'&usertype='+usertype+'&lawyerid='+lawyerid);
    },
   systemlawyer: function(city){
        return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=systemlawyer&city='+city);
    },
	
    rm_collection: function(userid,usertype,lawyerid){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=collection&act2=rm&userid='+userid+'&usertype='+usertype+'&lawyerid='+lawyerid);
    },
    info: function(userid,usertype,id){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=info&id='+id).then(function (result) {
        if (userid != "" && usertype != "") {
          var array = [];
          return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=get_collection&userid='+userid+'&usertype='+usertype).then(function (result2) {
			if(result2.data!=""){  
            var collections = _.compact(result2.data.data[0].collection);
             var lawyerid = result.data.data[0].id
            var array_content = _.assign(result.data.data[0], {"show": false})
              for (var j = 0; j < collections.length; j++) {
                if (collections[j] == lawyerid) {
                  array_content = _.assign(result.data.data[0], {"show": true})
                }

              }
            array = _.concat(array, array_content);
            return array
			  }else{	
			return  result.data.data	
				}
          })
        }
        else {
          return  result.data.data
        }
      });
    },
	 getfile: function(userid){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=getfile&userid='+userid)
    },
	 lawyerfile: function(userid,lawyername,number,firmname,qq,sheng,shi,adress,zhuanchang,headimg,credentials){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=lawyerfile&userid='+userid+'&lawyername='+lawyername+'&number='+number+'&firmname='+firmname+'&qq='+qq+'&sheng='+sheng+'&shi='+shi+'&adress='+adress+'&zhuanchang='+zhuanchang+'&headimg='+headimg+'&credentials='+credentials)
	 },
	  introduce: function(userid,self){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=introduce&userid='+userid+'&self='+self)
	 }, 
	  certification: function(userid){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=certification&userid='+userid)
	 }, 
	  changetype: function(userid){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=changetype&userid='+userid)
	 }, 
	   get_message: function(userid,usertype,status){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=get_message&userid='+userid+'&usertype='+usertype+'&status='+status);
    },
    lawyerdata: function(userid,usertype,page,city,category){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=list&city='+city+'&category='+category+'&page='+page).then(function (result) {
        if (userid != "" && userid != "") {
          var array = [];
          return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=get_collection&userid='+userid+'&usertype='+usertype).then(function (result2) {
			if(result2.data!=""){
            var collections = _.compact(result2.data.data[0].collection);
            for (var i = 0; i < result.data.data.length; i++) {
              var lawyerid = result.data.data[i].id
              var array_content = _.assign(result.data.data[i], {"show": false})
              for (var j = 0; j < collections.length; j++) {
                if (collections[j] == lawyerid) {
                 array_content = _.assign(result.data.data[i], {"show": true})
                }
              }
              array = _.concat(array, array_content);
            }
            return array
			}else{	
			return  result.data.data	
				}
          })
        }
        else {
          return  result.data.data
        }
      });
    }
  };

}])


  .factory('Question',['$http',function Question($http) {
    return {
      list: function(page,city,category,keyword){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=list&shi='+city+'&category='+category+'&keyword='+keyword+'&page='+page);
      },
	   mylist: function(userid,usertype,page){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=mylist&userid='+userid+'&usertype='+usertype+'&page='+page);
      },
	  mylistenlist: function(userid,usertype,page){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=mylistenlist&userid='+userid+'&usertype='+usertype+'&page='+page);
      },
	   lawyerAnswerlist: function(lawyerid,page){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=lawyeranswerlist&lawyerid='+lawyerid+'&page='+page);
      },
	   sameTypelist: function(questionType,page){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?go=questionlist&act=sametypelist&questiontype='+questionType+'&page='+page);
      },
      info: function(id){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=info&id='+id);
      },
	  get_answer: function(qid){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=get_answer&qid='+qid);
      },
	  answer: function(qid,lawyerid,answer,leixing,voice,duration){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=answer&qid='+qid+'&lawyerid='+lawyerid+'&answer='+answer+'&voice='+voice+'&leixing='+leixing+'&duration='+duration);
      },
	  sms: function(mobile){
        return $http.get("http://www.iflawyer.com/admin/sms3.asp?mobile="+mobile+"&send_code=1234");
      },
	
	    listen: function(userid,usertype,qid,answerid){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=listen&userid='+userid+'&usertype='+usertype+'&qid='+qid+'&answerid='+answerid);
      },
	   addTime: function(qid){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=addtime&qid='+qid);
      }
    };
  }])
  
   .factory('Report',['$http',function Report($http) {
    return {
	   mylist: function(userid,usertype,page){
        return $http.get('http://www.iflawyer.com/app/report_cx.asp?act=mylist&userid='+userid+'&usertype='+usertype+'&page='+page);
      }
	  
    };
  }])

  .factory('Consult',['$http',function Consult($http) {
    return {
      submit: function(userid,usertype,username,tel,category,content,province,city){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=submit&usertype='+usertype+'&userid='+
          userid+'&tel='+tel+'&category='+category+'&content='+content+'&username='+username+'&province='+province+'&city='+city);
      },
	   case: function(userid,tel,category,content,lawyerfee,city){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=case&userid='+
          userid+'&tel='+tel+'&category='+category+'&content='+content+'&city='+city+'&lawyerfee='+lawyerfee);
      }
    };
  }])

  .factory('index',['$http',function index($http) {
	
  return {
    daily: function(subject){
      return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=daily&subject='+subject);
    },
	  dailyAnswer: function(qid){
      return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=daily_answer&qid='+qid);
    },
    question: function(subject){
      return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=ask&page=0&subject='+subject);
    },
    recommendLawyer: function(subject){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=recommend&subject='+subject);
    }
   
  };
}])


  .factory('Person',['$http',function Person($http) {
    return {
      collectedLawyer: function(userid,usertype,page){
        return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=collectedlawyer&userid='+userid+'&usertype='+usertype+'&page='+page);
      },
      remaining: function(userid,usertype,fee){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=remaining&usertype='+usertype+'&userid='+userid+'&fee='+fee);
      },
	  info: function(userid,usertype){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=info&usertype='+usertype+'&userid='+userid);
      },
	   personfile: function(userid,usertype,username,sex,born,education,state,city,headimg){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=personfile&usertype='+usertype+'&userid='+userid+'&username='+username+'&sex='+sex+'&born='+born+'&education='+education+'&state='+state+'&city='+city+'&headimg='+headimg);
      },
	   getDistrict:function(){
        return $http.get('http://www.iflawyer.com/app/system_cx.asp?act=getDistrict');
      }
	 
	  
    };
  }])
  


.factory('Chater',['$http',function Chater($http) {

  return {
    list: function(){
      return $http.get('http://www.iflawyer.com/m2/online_cxm2.asp?act=list');
    },	
	 get: function(userid,usertype,targetid) {
	return $http.get('http://www.iflawyer.com/app/chater_cx.asp?act=get&userid='+userid+'&usertype='+usertype+'&targetid='+targetid);
    },
	add: function(userid,usertype,targetid,ask,neirong){
      return $http.get('http://www.iflawyer.com/app/chater_cx.asp?act=add&userid='+userid+'&usertype='+usertype+'&targetid='+targetid+'&ask='+ask+'&neirong='+neirong);
    },
	more: function(userid,usertype,lawyerid,jine){
      return $http.get('http://www.iflawyer.com/app/chater_cx.asp?act=more&userid='+userid+'&usertype='+usertype+'&lawyerid='+lawyerid+'&jine='+jine);
    }
	
  };
}])
.factory('Rongcloud',['$http',function Rongcloud($http) {
	
  return {
    token: function(userid,usertype,userimg){
      return $http.get('http://www.iflawyer.com/app/rongcloud.php?act=token&userid='+userid+'&usertype='+usertype+'&userimg='+userimg);
    }
	
	
		
  };
  
  
  
  
  
}])


.factory('Chater_detail',['$http',function Chater_detail($http) {
  return {
    list: function(chat_arry){
	var type
	var chat_arry2 = new Array();
	for (var i=0;i<chat_arry.length;i++){
		if (chat_arry[i].indexOf('ask')>-1){
		type=true	
			}else
		{type=false
			}
	chat_arry[i]=chat_arry[i].replace('ask','')
	chat_arry[i]=chat_arry[i].replace('dafu','')
	if (chat_arry[i]!=''){
	var chat_obj=new Object();
	chat_obj.name=chat_arry[i];	
	chat_obj.type=type;
	chat_arry2.push(chat_obj);
	}
		}  
	  
	return chat_arry2  
    }
	
  };
}])

.factory('audioPlay',['$cordovaMedia','$cordovaFileTransfer','$ionicPlatform','$cordovaFile','$timeout',function audioPlay($cordovaMedia, $cordovaFileTransfer,$ionicPlatform,$cordovaFile,$timeout) {
  return {
    loadready: function (url) {
      var fileName=new Date().getTime();
      document.addEventListener('deviceready', function () {
        var targetPath = cordova.file.cacheDirectory + fileName+".mp3";
        var trustHosts = true;
        var options = {};
        $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
          .then(function(result) {
            // Success
            var media = $cordovaMedia.newMedia(targetPath);
			return media
          }, function(err) {
            // Error
          }, function (progress) {
            $timeout(function () {
            });
          });
      }, false);
    }
	
  };
}])

.factory('fileUpload', ['$http', function ($http) {
            var uploadFileToUrl = function(file, uploadUrl){
                var fd = new FormData();
                fd.append('file', file);
                $http.post(uploadUrl, fd, {
                    transformRequest: angular.identity,
                    headers: {'Content-Type': undefined}
                })
                .success(function(){
                   
                })
                .error(function(){
                    alert("error，图片上传失败！");
                });
            };
            
            return {
                uploadFileToUrl : uploadFileToUrl 
            };
        }])
		
	
.factory('wechatService', [
            function () {
                // 检测是否安装插件
                if (typeof Wechat === "undefined") {
                    console.log("Wechat plugin is not installed.");
                    return false;
                }

                return {
                    // 检测微信客户端是否安装
                    isInstalled: function (callback) {
                        Wechat.isInstalled(function (installed) {
                            if (callback && typeof callback === 'function') {
                                callback(installed);
                            }
                        });
                    },

                    // 分享参数 scene 0 是会话 1 是朋友圈 2 是收藏 ; message 是分享的消息对象
                    share: function (scene, message, suc, fail) {
                        var params = {
                            scene: scene
                        };

                        // 配置消息类型
                        params.message = {
                            title: message.title || '',
                            description: message.description || '',
                            mediaTagName: message.mediaTagName || "",
                            messageExt: message.messageExt || "",
                            messageAction: message.messageAction || "",
                            thumb: message.thumb || "images/common/about-logo.png",
                            media: message.media || {}
                        };

                        // 开始分享
                        if (suc && fail && typeof suc === 'function' && typeof fail === 'function') {
                            Wechat.share(params, suc, function (reason) {
                                fail(reason);
                            });
                        }
                    },

                    // 登录
                    login: function (callback) {
                        Wechat.auth("snsapi_userinfo", function (response) {
                            callback && angular.isFunction(callback) && callback(response);
                        }, function () {
                            callback && angular.isFunction(callback) && callback(false);
                        });
                    }

                };
            }])
			


  // 微信支付
.factory('PayService',['$http','$rootScope','$state','$ionicPopup','$ionicViewSwitcher',function PayService($http,$rootScope,$state,$ionicPopup,$ionicViewSwitcher){
  return {
    getJson:function(orderid,jine){
       return $http.get("http://www.iflawyer.com/app/wepay.php?jine="+jine+"&orderid="+orderid);
    },
	 getJson_alipay:function(orderid,jine){
       return $http.get("http://pay.iflawyer.com/alipay/alipay.php?jine="+jine+"&orderid="+orderid);
    },
	orderlist:function(page,city,category,keyword){
       return $http.get("http://www.iflawyer.com/app/order.asp?act=orderlist&page="+page+"&shi="+city+"&category="+category+"&keyword="+keyword);
    },
	getorder:function(id,lawyerid){
       return $http.get("http://www.iflawyer.com/app/order.asp?act=getorder&id="+id+"&lawyerid="+lawyerid);
    },
	order:function(userid,usertype,username,tel,jine,city,orderid,xiangmu){
       return $http.get("http://www.iflawyer.com/app/order.asp?act=order&userid="+userid+"&usertype="+usertype+"&username="+username+"&tel="+tel+"&jine="+jine+"&city="+city+"&orderid="+orderid+"&xiangmu="+xiangmu);

    },
	 tradeRecord:function(userid,usertype,page){
      return $http.get("http://www.iflawyer.com/app/order.asp?act=traderecord&userid="+userid+"&usertype="+usertype+"&page="+page);
    },
	deposit:function(userid,usertype,jine,orderid){
       return $http.get("http://www.iflawyer.com/app/order.asp?act=pay&userid="+userid+"&usertype="+usertype+"&jine="+jine+"&orderid="+orderid);
    },
	pay: function(jine,xiangmu){
	    var orderid= new Date().getTime();
		var userid=$rootScope.currentUserId
		var usertype=$rootScope.currentUserType
		var username=$rootScope.currentUserName
		var tel=$rootScope.currentUserTel
		var city=$rootScope.city
		var info
		var qid
	
		if (xiangmu.indexOf('在线咨询')>-1){
			qid=xiangmu.slice(4,xiangmu.length)
			xiangmu='在线咨询'
		
			}
		
	    if (userid!=''&&usertype!=''){
		//下单 
		 $http.get("http://www.iflawyer.com/app/order.asp?act=order&userid="+userid+"&usertype="+usertype+"&username="+username+"&tel="+tel+"&jine="+jine+"&city="+city+"&orderid="+orderid+"&xiangmu="+xiangmu).then(function(result1){
	  
			  info="orderSucess"
			   });
	//验证余额是否充足		   
	 $http.get('http://www.iflawyer.com/app/person_cx.asp?act=remaining&usertype='+usertype+'&userid='+userid+'&fee='+jine).then(function (result2) {
		
         if(result2.data.data == 1){
			 //改变下单付款状态
		$http.get("http://www.iflawyer.com/app/order.asp?act=pay&userid="+userid+"&usertype="+usertype+"&jine="+jine+"&orderid="+orderid).then(function(result3){
			
			  info="sucess"
			   });
		
		if(xiangmu=='在线咨询'){
		
			$http.get("http://www.iflawyer.com/app/question_cx.asp?act=fee&qid="+qid+"&jine="+jine).then(function(ret) {          
		    $ionicPopup.alert({title: "支付成功，稍后将有律师回答您的咨询，请关注消息提醒"}).then(function(){
			 $state.go('tab.online_list');
	        $ionicViewSwitcher.nextDirection("forward"); 
			 });
			 });
			
			}else{
			$ionicPopup.alert({title: "支付成功，稍后将有律师与您联系，请保持手机畅通"});
			}
		  
		 
		
         }else if(result2.data.data == 0){
			  $ionicPopup.alert({title: "您的余额不足请充值"}).then(function(){
				  $state.go('pay',{});
		    $ionicViewSwitcher.nextDirection("forward");  
				  
				  })
          
         }else {
		   $ionicPopup.alert({title: "付款失败，请登录"}).then(function(){
				$state.go('start',{});
		    $ionicViewSwitcher.nextDirection("forward"); 
				  
				  })
           
         }

        })
		
		}else{
		
		 $ionicPopup.alert({title: "请先登陆"}).then(function(){
		 $state.go('start',{});
		 $ionicViewSwitcher.nextDirection("forward");   
				  })
		
		      }//登陆结束
	   
 
    }
  };
}])

  // 上传文件
  
.factory('uploadfile',['$http','$cordovaFile',function uploadfile($http,$cordovaFile){
	 return {
    upload:function(imageURI,dataType,filename,leixing){
      window.resolveLocalFileSystemURL(imageURI,function(fileEntry) { 
    fileEntry.file(function(file) { 
      var reader = new FileReader(); 
      reader.onloadend = function(e) { 
        //需要将图片路径转换为二进制流，并且指定类型为图像格式（还有其他格式，如文本格式等等） 
        var the_file = new Blob([e.target.result ], { type: dataType} ); 
		
		var fd = new FormData();
		
        fd.append("file", the_file,filename); 
        $http({
              method:'POST',
              url:"http://www.iflawyer.com/app/upload.php?leixing="+leixing,
              data: fd,
              headers: {'Content-Type':undefined},
              transformRequest: angular.identity 
               })   
              
		
       
      }; 
      reader.readAsArrayBuffer(file); 
    }, function(e){$scope.errorHandler(e)}); 
  }, function(e){$scope.errorHandler(e)});   
    }
	 };
}])



