angular.module('starter.services', ['ngCordova'])

.factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    }
  }
}])
//注册
.factory('RegisterService',['$http',function RegisterService($http) {
  return {
 
    getVerificationCode: function(mobile){
      return $http.get("http://www.iflawyer.com/www2/sms.asp?mobile="+mobile+"&send_code=1234");
    },

	checktel: function(mobile){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=checktel&mobile="+mobile);
    },
	checkcode: function(code){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=checkcode&code="+code);
    },
	resetpsw: function(mobile,password){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=resetpsw&password="+password+"&mobile="+mobile);
    },
    register: function(logonName,password,mobile){
      return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=register&logonName="+logonName+"&password="+password+"&mobile="+mobile);
    }
  };
}])
//注册结束
//登陆
.factory('LogonService',['$http',function LogonService($http) {
  return {
    logon: function(mobile,password){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=logon&password="+password+"&mobile="+mobile);
    },
	 getOpenid: function(code){
       return $http.get("https://api.weixin.qq.com/sns/oauth2/access_token?appid=wx277d1ecc36b3fb83&secret=97bcccb73ee0aef8b0a746bd0ba4e36f&code="+code+"&grant_type=authorization_code");
    },
	 getUserinfo: function(token,openid){
       return $http.get("https://api.weixin.qq.com/sns/userinfo?access_token="+token+"&openid="+openid);
    },
	 wechatlogon: function(openid,headimg){
       return $http.get("http://www.iflawyer.com/app/reg_cx.asp?act=wechatlogon&openid="+openid+"&headimg="+headimg);
    }
  };
}])

  .factory('Lawyer',['$http',function Lawyer($http) {
  return {
    collection: function(userid,usertype,lawyerid){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=collection&userid='+userid+'&usertype='+usertype+'&lawyerid='+lawyerid);
    },
    rm_collection: function(userid,usertype,lawyerid){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=collection&act2=rm&userid='+userid+'&usertype='+usertype+'&lawyerid='+lawyerid);
    },
    info: function(userid,usertype,id){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=info&id='+id).then(function (result) {
        if (userid != "" && usertype != "") {
          var array = [];
          return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=get_collection&userid='+userid+'&usertype='+usertype).then(function (result2) {
			  
            var collections = _.compact(result2.data.data[0].collection);
             var lawyerid = result.data.data[0].id
            var array_content = _.assign(result.data.data[0], {"show": false})
              for (var j = 0; j < collections.length; j++) {
                if (collections[j] == lawyerid) {
                  array_content = _.assign(result.data.data[0], {"show": true})
                }

              }
            array = _.concat(array, array_content);
            return array
			
          })
        }
        else {
          return  result.data.data
        }
      });
    },
    lawyerdata: function(userid,usertype,page){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=list&page='+page).then(function (result) {
        if (userid != "" && usertype != "") {
          var array = [];
          return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=get_collection&userid='+userid+'&usertype='+usertype).then(function (result2) {
            var collections = _.compact(result2.data.data[0].collection);
            for (var i = 0; i < result.data.data.length; i++) {
              var lawyerid = result.data.data[i].id
              var array_content = _.assign(result.data.data[i], {"show": false})
              for (var j = 0; j < collections.length; j++) {
                if (collections[j] == lawyerid) {
                 array_content = _.assign(result.data.data[i], {"show": true})
                }
              }
              array = _.concat(array, array_content);
            }
            return array
          })
        }
        else {
          return  result.data.data
        }
      });
    }
  };

}])


  .factory('Question',['$http',function Question($http) {
    return {
      list: function(page){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=list&page='+page);
      },
      info: function(id){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=info&id='+id);
      },
	  get_answer: function(qid){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=get_answer&qid='+qid);
      },
	  answer: function(qid,lawyerid,answer,leixing,voice,duration){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=answer&qid='+qid+'&lawyerid='+lawyerid+'&answer='+answer+'&voice='+voice+'&leixing='+leixing+'&duration='+duration);
      },
	    listen: function(userid,usertype,qid,answerid){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=listen&userid='+userid+'&usertype='+usertype+'&qid='+qid+'&answerid='+answerid);
      }
    };
  }])

  .factory('Consult',['$http',function Consult($http) {
    return {
      submit: function(userid,usertype,username,tel,category,content,province,city){
        return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=submit&usertype='+usertype+'&userid='+
          userid+'&tel='+tel+'&category='+category+'&content='+content+'&username='+username+'&province='+province+'&city='+city);
      }
    };
  }])

  .factory('index',['$http',function index($http) {
  return {
    daily: function(){
      return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=daily');
    },
    ask: function(){
      return $http.get('http://www.iflawyer.com/app/question_cx.asp?act=ask&page=0');
    },
    reco: function(){
      return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=reco');
    }
  };
}])

  .factory('Person',['$http',function Person($http) {
    return {
      collectedLawyer: function(userid,usertype,page){
        return $http.get('http://www.iflawyer.com/app/lawyer_cx.asp?act=collectedlawyer&userid='+userid+'&usertype='+usertype+'&page='+page);
      },
      remaining: function(userid,usertype,fee){
        return $http.get('http://www.iflawyer.com/app/person_cx.asp?act=remaining&usertype='+usertype+'&userid='+userid+'&fee='+fee);
      }
    };
  }])
  


.factory('Chater',['$http',function Chater($http) {
  return {
    list: function(){
      return $http.get('http://www.iflawyer.com/m2/online_cxm2.asp?act=list');
    },	
	 get: function(x,chatId) {
	return $http.get('http://www.iflawyer.com/m2/online_cxm2.asp?act=get&id='+chatId+'&x='+x);
    },
	add: function(max_riqi){
      return $http.get('http://www.iflawyer.com/m2/online_cxm2.asp?act=add_list&max_riqi='+max_riqi);
    }	
   
	
  };
}])


.factory('Chater_detail',['$http',function Chater_detail($http) {
  return {
    list: function(chat_arry){
	var type
	var chat_arry2 = new Array();
	for (var i=0;i<chat_arry.length;i++){
		if (chat_arry[i].indexOf('ask')>-1){
		type=true	
			}else
		{type=false
			}
	chat_arry[i]=chat_arry[i].replace('ask','')
	chat_arry[i]=chat_arry[i].replace('dafu','')
	if (chat_arry[i]!=''){
	var chat_obj=new Object();
	chat_obj.name=chat_arry[i];	
	chat_obj.type=type;
	chat_arry2.push(chat_obj);
	}
		}  
	  
	return chat_arry2  
    }
	
  };
}])

.factory('audioPlay',['$cordovaMedia','$cordovaFileTransfer','$ionicPlatform','$cordovaFile','$timeout',function audioPlay($cordovaMedia, $cordovaFileTransfer,$ionicPlatform,$cordovaFile,$timeout) {
  return {
    loadready: function (url) {
      var fileName=new Date().getTime();
      document.addEventListener('deviceready', function () {
        var targetPath = cordova.file.cacheDirectory + fileName+".mp3";
        var trustHosts = true;
        var options = {};
        $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
          .then(function(result) {
            // Success
            var media = $cordovaMedia.newMedia(targetPath);
			return media
          }, function(err) {
            // Error
          }, function (progress) {
            $timeout(function () {
            });
          });
      }, false);
    }
	
  };
}])

.factory('fileUpload', ['$http', function ($http) {
            var uploadFileToUrl = function(file, uploadUrl){
                var fd = new FormData();
                fd.append('file', file);
                $http.post(uploadUrl, fd, {
                    transformRequest: angular.identity,
                    headers: {'Content-Type': undefined}
                })
                .success(function(){
                    alert("图片上传成功！");
                })
                .error(function(){
                    alert("error，图片上传失败！");
                });
            };
            
            return {
                uploadFileToUrl : uploadFileToUrl 
            };
        }])
		
	
.factory('wechatService', [
            function () {
                // 检测是否安装插件
                if (typeof Wechat === "undefined") {
                    console.log("Wechat plugin is not installed.");
                    return false;
                }

                return {
                    // 检测微信客户端是否安装
                    isInstalled: function (callback) {
                        Wechat.isInstalled(function (installed) {
                            if (callback && typeof callback === 'function') {
                                callback(installed);
                            }
                        });
                    },

                    // 分享参数 scene 0 是会话 1 是朋友圈 2 是收藏 ; message 是分享的消息对象
                    share: function (scene, message, suc, fail) {
                        var params = {
                            scene: scene
                        };

                        // 配置消息类型
                        params.message = {
                            title: message.title || '',
                            description: message.description || '',
                            mediaTagName: message.mediaTagName || "",
                            messageExt: message.messageExt || "",
                            messageAction: message.messageAction || "",
                            thumb: message.thumb || "images/common/about-logo.png",
                            media: message.media || {}
                        };

                        // 开始分享
                        if (suc && fail && typeof suc === 'function' && typeof fail === 'function') {
                            Wechat.share(params, suc, function (reason) {
                                fail(reason);
                            });
                        }
                    },

                    // 登录
                    login: function (callback) {
                        Wechat.auth("snsapi_userinfo", function (response) {
                            callback && angular.isFunction(callback) && callback(response);
                        }, function () {
                            callback && angular.isFunction(callback) && callback(false);
                        });
                    }

                };
            }])

  // 微信支付
.factory('PayService',['$http',function PayService($http){
  return {
    getJson:function(){
       return $http.get("http://www.iflawyer.com/wechat/wepay.php");
    }
  };
}])

  // 上传文件
  
.factory('uploadfile',['$http','$cordovaFile',function uploadfile($http,$cordovaFile){
	 return {
    upload:function(imageURI,dataType,filename,leixing){
      window.resolveLocalFileSystemURL(imageURI,function(fileEntry) { 
    fileEntry.file(function(file) { 
      var reader = new FileReader(); 
      reader.onloadend = function(e) { 
        //需要将图片路径转换为二进制流，并且指定类型为图像格式（还有其他格式，如文本格式等等） 
        var the_file = new Blob([e.target.result ], { type: dataType} ); 
		
		var fd = new FormData();
		
        fd.append("file", the_file,filename); 
        $http({
              method:'POST',
              url:"http://www.iflawyer.com/app/upload.php?leixing="+leixing,
              data: fd,
              headers: {'Content-Type':undefined},
              transformRequest: angular.identity 
               })   
              
		
       
      }; 
      reader.readAsArrayBuffer(file); 
    }, function(e){$scope.errorHandler(e)}); 
  }, function(e){$scope.errorHandler(e)});   
    }
	 };
}])



